/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef DPC_IMPL_TYPE_MSGHEADER_H
#define DPC_IMPL_TYPE_MSGHEADER_H

#include "impl_type_uint64.h"
#include "impl_type_uint16.h"
#include "dpc/impl_type_array_uint8_t_2.h"

namespace dpc {
struct MsgHeader {
    ::UInt64 time_stamp{ 0U };
    ::UInt16 cycle_counter{ 0U };
    ::dpc::array_uint8_t_2 padding{};

    static bool IsPlane()
    {
        return false;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(time_stamp);
        fun(cycle_counter);
        fun(padding);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(time_stamp);
        fun(cycle_counter);
        fun(padding);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("time_stamp", time_stamp);
        fun("cycle_counter", cycle_counter);
        fun("padding", padding);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("time_stamp", time_stamp);
        fun("cycle_counter", cycle_counter);
        fun("padding", padding);
    }

    friend bool operator==(const ::dpc::MsgHeader& lhs, const ::dpc::MsgHeader& rhs) noexcept
    {
        return (lhs.time_stamp == rhs.time_stamp) && (lhs.cycle_counter == rhs.cycle_counter) && (lhs.padding == rhs.padding);
    }
};
} // namespace dpc


#endif // DPC_IMPL_TYPE_MSGHEADER_H
